/*
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

#ifndef MIRAI_TASKSVIEW_H
#define MIRAI_TASKSVIEW_H
#include "TasksFile.h"
#include "core/Mirai.h"
#include "using.h"
#include <cstddef>
#include <memory>
#include <string>

namespace mirai
{

class TasksView
{

  public:
	TasksView(Mirai *mirai);

	TaskItem &operator[](int index);

	size_t count() const;
	void update();
	void addTagFilter(const std::string &tag);
	void removeTagFilter(const std::string &tag);
	void addFileFilter(const std::string &fileName);
	void removeFileFilter(const std::string &fileName);
	void removeFilters();
	const Tags &getActiveTagsFilter();
	const std::vector<std::string> &getActiveFilesFilter();

  private:
	Mirai *mirai;
	std::vector<TaskItem *> tasksToShow;
	Tags tagsFilter;
	std::vector<std::string> filesFilter;
};
} // namespace mirai
#endif
